C $DIR CONFIG INFORMATION
C $DIR PART init
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
        SUBROUTINE init(pi,gam1,fi,an,dx,x1,x2,qu,its,irun,dt)
        INCLUDE 'TASK.PAR'
        real qu(Nx,Ny,4)
        real x1(Nx),x2(Ny)
        character*20 NAME
        NAME(1:2)='QU'
        write(NAME(2: ),'(I5.5)')
        open(44,file='TIMER')
        read(44,676)irun,its,dt
        close(44)
677     format(4(e14.7))
676     format(2(i8),e14.7)
        db=1.0
        dx=db/(Ny-1)
        x1(1)=-2.*dx
        DO I=2,Nx
           x1(I)=x1(I-1)+dx
        ENDDO
        x2(1)=-2.*dx
        DO I=2,Ny
        x2(I)=x2(I-1)+dx
        ENDDO
        if(irun.eq.0) then
        DO J=1,Ny
        DO I=1,Nx
         IF(x1(i).LT.AN+x2(J)/TAN(fi)) THEN
           QU(I,J,1)=8.
           QU(I,J,2)=8.25*SIN(PI/4.)*QU(I,J,1)
           QU(I,J,3)=-8.25*COS(PI/4.)*QU(I,J,1)
           QU(I,J,4)=116.5/gam1+(QU(I,J,2)**2+QU(I,J,3)**2)/2./QU(I,J,1)
         ELSE
           QU(I,J,1)=1.4
           QU(I,J,2)=0.
           QU(I,J,3)=0.
           QU(I,J,4)=1./gam1
         ENDIF
        ENDDO
        ENDDO
        else
         open(44,file=NAME)
         do J=1,Ny
         do I=1,Nx
         read(44,677)(QU(i,j,m),m=1,4)
         enddo
         enddo
         close(44)
         endif
         return
         end
C $DIR CONFIG INFORMATION
C $DIR PART writer
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
        subroutine writer(irun,it,dt,qu)
        include 'TASK.PAR'
        real qu(Nx,Ny,4)
        character*20 NAME
        NAME(1:2)='QU'
        irun=irun+1
        write(NAME(2: ),'(I5.5)')irun
        open(44,file='TIMER')
        write(44,676)irun,it,dt
        close(44)
676     format(2(i8),e14.7)
        open(44,file=NAME)
        do J=1,Ny
        do I=1,Nx
          write(44,677)(qu(i,j,m),m=1,4)
        enddo
        enddo
677     format(4(e14.7))
        close(44)
        return
        end
C $DIR CONFIG INFORMATION
C $DIR PART step1
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
        SUBROUTINE step1(gam1,gamma,c0,dx,qu,umin)
        real QU(4)
        DTM=1.E+10
        PRR=GAM1*(QU(4)-(QU(2)**2+QU(3)**2)/2./QU(1)) 
        CL=SQRT(GAMMA*PRR/QU(1))
        UCSX=QU(2)/QU(1)
        UCSY=QU(3)/QU(1)
        DTMX=1./(ABS(UCSX)+CL)
        DTMY=1./(ABS(UCSY)+CL)
        umin= C0*DX*AMIN1(DTM,DTMX,DTMY)
        return
        end
C $DIR CONFIG INFORMATION
C $DIR PART cslx
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
        Subroutine cslx(gam1,qu1,qu2,qsr,slp,csr)
        real qu1(4),qu2(4),qsr(5),slp(4),csr
        QR1=qu1(1)-qu2(1)
        QR2=qu1(2)-qu2(2)
        QR3=qu1(3)-qu2(3)
        QR4=qu1(4)-qu2(4)
        csr=SQRT(qsr(5))
        TMX=QSR(2)/csr
        TMY=QSR(3)/csr
        TM2=gam1*(TMX**2+TMY**2)/2.
        TMC=gam1*TMX/csr
        TMD=gam1*TMY/csr
        GMC=gam1/csr**2
        CS2=1./csr
        slp(1)=((TMX+TM2)*QR1-(CS2+TMC)*QR2-
     > TMD*QR3+GMC*QR4)/2.
        slp(2)=((1.-TMY-TM2)*QR1
     > +TMC*QR2+(CS2+TMD)*QR3-GMC*QR4)/2.
        slp(3)=((1.+TMY-TM2)*QR1+TMC*QR2-
     > (CS2-TMD)*QR3-GMC*QR4)/2.
        slp(4)=((-TMX+TM2)*QR1+(CS2-TMC)*QR2-
     > TMD*QR3+GMC*QR4)/2.
        return
        end
C $DIR CONFIG INFORMATION
C $DIR PART csly
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
        Subroutine csly(gam1,qu1,qu2,qsr,slp,csr)
        real qu1(4),qu2(4),qsr(5),slp(4),csr
        QR1=qu1(1)-qu2(1)
        QR2=qu1(2)-qu2(2)
        QR3=qu1(3)-qu2(3)
        QR4=qu1(4)-qu2(4)
        csr=SQRT(qsr(5))
        TMX=QSR(2)/csr
        TMY=QSR(3)/csr
        TM2=gam1*(TMX**2+TMY**2)/2.
        TMC=gam1*TMX/csr
        TMD=gam1*TMY/csr
        GMC=gam1/csr**2
        CS2=1./csr
       SLP(1)=((TMY+TM2)*QR1-TMC*QR2-(CS2+TMD)*QR3+GMC*QR4)/2.
       SLP(2)=((1.-TMX-TM2)*QR1+(CS2+TMC)*QR2+TMD*QR3-GMC*QR4)/2.
       SLP(3)=((1.+TMX-TM2)*QR1-(CS2-TMC)*QR2+TMD*QR3-GMC*QR4)/2.
       SLP(4)=((-TMY+TM2)*QR1-TMC*QR2+(CS2-TMD)*QR3+GMC*QR4)/2.
        return
        end
C $DIR CONFIG INFORMATION
C $DIR PART FF
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
      FUNCTION FF(X,MH)
C      COMMON/DEP/EPS,MH

        EPS=0.05
        FF=ABS(X)
      IF(MH.EQ.1.OR.MH.EQ.4) THEN
       IF(FF.LT.2.*EPS) THEN
        FF=(X**2/(4.*EPS))+EPS
       ENDIF
      ENDIF

      RETURN
      END
C $DIR CONFIG INFORMATION
C $DIR PART coeff
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
      SUBROUTINE coeff(ijk,A9,B9,C9,D9,A1,A2)
      IF(IJK.EQ.1) THEN
       A1=0.
       A2=1.
      ELSE
       IF(IJK.EQ.2) THEN
       A1=B9
       A2=A9
       ELSE
       A1=C9
       A2=D9
      ENDIF
      ENDIF
      RETURN
      END
C $DIR CONFIG INFORMATION
C $DIR PART upbound
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
      SUBROUTINE upbound(qu,i,j,x1,x2,dt0,fi,an,pi,gam1,qu4)
        INCLUDE 'TASK.PAR'
        real qu(4),qu4(4)
        real x1(Nx),x2(Ny)
         XT1=10.*DT0/SIN(FI)+AN+X2(J)/TAN(FI)
       IF(X1(I).LT.XT1) THEN
         QU4(1)=8.
         QU4(2)=8.25*SIN(PI/4.)*QU(1)
         QU4(3)=-8.25*COS(PI/4.)*QU(1)
         QU4(4)=116.5/GAM1+(QU(2)**2+QU(3)**2)/2./QU(1)
        ELSE
         QU4(1)=1.4
         QU4(2)=0.
         QU4(3)=0.
         QU4(4)=1./GAM1
        ENDIF
       return
       end
C $DIR CONFIG INFORMATION
C $DIR PART downbound
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
      SUBROUTINE downbound(qu,qu3,i,x1,an,pi,gam1,qu4)
        INCLUDE 'TASK.PAR'
        real qu(4),qu4(4),qu3(4)
        real x1(Nx)

        IF(X1(I).GT.AN) THEN
            QU4(1)=QU3(1)
            QU4(2)=QU3(2)
            QU4(3)=0.
            QU4(4)=QU3(4)

C        IF(X1(I).GT.AN) THEN
            QU3(3)=ABS(QU3(3))
C         ENDIF

        ELSE
         QU4(1)=8.
         QU4(2)=8.25*SIN(PI/4.)*QU(1)
         QU4(3)=-8.25*COS(PI/4.)*QU(1)
         QU4(4)=116.5/GAM1+(QU(2)**2+QU(3)**2)/2./QU(1)
        ENDIF

         return
         end






